Studio state allows reports to be saved and restored. Reports can be created in edit mode, saved down as state, and then reloaded in view mode.
Saving and Restoring State Copy Link
import {
AgReportState,
AgStudioApi,
AgStudioPreDestroyedEvent,
AgStudioProperties,
AgStudioStateUpdatedEvent,
createStudio,
enableStudioDevValidations,
} from "ag-studio";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const initialState: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
"2": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
"2": {
xTrack: 0,
yTrack: 16,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
const studioProperties: AgStudioProperties = {
mode: "edit",
initialState,
onStateUpdated,
onStudioPreDestroyed,
};
let studioApi: AgStudioApi;
const EMPTY_STATE: AgReportState = {
pages: [
{
id: "page-1",
},
],
selectedPageId: "page-1",
};
let savedState: AgReportState = EMPTY_STATE;
function clearState() {
studioApi.setState(EMPTY_STATE);
}
function saveState() {
const state = studioApi.getState();
console.log("Current state", state);
savedState = state;
}
function restoreState() {
studioApi.setState(savedState);
}
function hardcodedState() {
studioApi.setState(initialState);
}
function recreate() {
const state = studioApi.getState();
studioApi.destroy();
studioProperties.initialState = state;
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data) =>
studioApi!.setProperty("data", {
sources: [{ id: "medals", data }],
}),
);
}
function onStateUpdated(event: AgStudioStateUpdatedEvent): void {
console.log("State updated", event.state);
}
function onStudioPreDestroyed(event: AgStudioPreDestroyedEvent): void {
console.log("Studio state on destroy", event.state);
}
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data) =>
studioApi!.setProperty("data", {
sources: [{ id: "medals", data }],
}),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).clearState = clearState;
(<any>window).saveState = saveState;
(<any>window).restoreState = restoreState;
(<any>window).hardcodedState = hardcodedState;
(<any>window).recreate = recreate;
}
<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button onclick="clearState()">Clear State</button>
<button onclick="saveState()">Save State</button>
<button onclick="restoreState()">Restore State</button>
<button onclick="hardcodedState()">Load Hardcoded State</button>
<button onclick="recreate()">Recreate Studio with Current State</button>
</div>
</div>
<div id="myStudio" class="my-studio-container"></div>
</div>
const studioProperties = {
initialState: {
pages: [
{
id: 'page-1',
widgets: {
'1': {
type: 'grid',
dataMapping: {
cols: [
{ id: 'medals.country' },
],
},
},
},
widgetLayout: {
'1': {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: 'page-1',
},
// other studio properties ...
}State is provided to Studio on initialisation via the initialState property.
Changes to state can also be stepped back and forward - see Undo & Redo.
State can be saved and restored on demand via the API methods getState() and setState().
Any time state changes, a stateUpdated event is emitted with the latest state. When Studio is destroyed, the studioPreDestroyed event is fired, which contains the latest state at the time.
These are all demonstrated in the above example. See the State API below for more details.
State is immutable. Studio uses reference equality to detect which parts of the state have changed, and updates them accordingly. If updating state and providing it back to Studio, ensure that a shallow copy is made to the depth of the changes.
Modes and State Copy Link
Switching between edit and view mode changes only what is shown and what is editable. The active state carries across the switch unchanged; Studio neither saves nor restores state on a mode change.
State changes made in view mode are emitted through stateUpdated exactly as in edit mode.
Applications that don't want to persist any view mode changes can do so themselves (e.g. where any edits made in view mode are discarded on returning to edit mode). Call getState() immediately before setting mode to 'view', and setState() with the saved state when setting mode back to 'edit':
const savedState = api.getState();
api.setProperty('mode', 'view');
// later, when returning to edit mode
api.setProperty('mode', 'edit');
api.setState(savedState); Changing Pages Copy Link
import {
AgReportState,
AgStudioApi,
AgStudioProperties,
createStudio,
enableStudioDevValidations,
} from "ag-studio";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const initialState: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
{
id: "page-2",
widgets: {
"1": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
const studioProperties: AgStudioProperties = {
mode: "edit",
initialState,
};
let studioApi: AgStudioApi;
function updatePage(pageId: string) {
const state = studioApi.getState();
studioApi.setState({
...state,
selectedPageId: pageId,
});
}
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data) =>
studioApi!.setProperty("data", {
sources: [{ id: "medals", data }],
}),
);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).updatePage = updatePage;
}
<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button onclick="updatePage('page-1')">Page 1</button>
<button onclick="updatePage('page-2')">Page 2</button>
</div>
</div>
<div id="myStudio" class="my-studio-container"></div>
</div>
Reports support multiple pages. These are all defined in state, with the currently displayed page set via the top-level selectedPageId state property. The page can be changed by getting the latest state from Studio and setting back a copy with the selectedPageId updated.
const state = api.getState();
api.setState({
...state,
selectedPageId: 'page-2',
}); Invalid State Copy Link
When state is invalid, Studio will do a "best-effort" attempt to load the state. This generally means removing invalid properties, which can leave widgets incomplete.
In Edit Mode, the UI can be used to fix the properties that were invalid, however in View Mode the user cannot make updates.
Studio will emit an errorRaised event with errorType: 'state' when there is invalid state (see Studio Events for how to listen to events). When in View Mode, where the report cannot be loaded properly, the event will have fatal: true.
It is recommended that you handle fatal error events by preventing the user from interacting with Studio. E.g. hiding Studio with your own error component, prompting the user to load a different report, switching into Edit Mode if the user has permissions, etc.
To help avoid invalid state, we strongly recommend creating state in the UI and then retrieving it from Studio. You can then make minor tweaks if required, rather than hand-crafting the entire state object.
State Versioning Copy Link
If there are breaking changes to the shape of the state object, Studio will try to automatically upgrade any provided state based on the version property.
version is always set with the current version when retrieving state from Studio.
If version is not set, Studio will assume that the state is for the current version, and will not perform any migrations.
Ensure that any saved-down state is read from Studio or has the version set. Otherwise you will have to manually update it if there are breaking changes to the shape of the state object.
State API Copy Link
Properties Copy Link
Initial state for Studio. Only read once on initialization. Can be used in conjunction with api.getState() to save and restore Studio state. |
API Methods Copy Link
Get the current state of Studio.
Can be used in conjunction with the initialState Studio property
or api.setState() to save and restore Studio state. |
Set the current state of Studio.
Can be used in conjunction with api.getState() or onStateUpdated
to save and restore Studio state.
The state is expected to be a full state object, not a partial state object.
State must be updated immutably as Studio uses reference equality
to determine which parts of state have changed. |
Events Copy Link
State has been updated. |
Invoked immediately before Studio is destroyed. This is useful for cleanup logic that needs to run before Studio is torn down. |

Studio state allows reports to be saved and restored. Reports can be created in edit mode, saved down as state, and then reloaded in view mode.
Saving and Restoring State Copy Link
"use client";
import type {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioPreDestroyedEvent,
AgStudioStateUpdatedEvent,
} from "ag-studio";
import { AgStudioApiReadyEvent, enableStudioDevValidations } from "ag-studio";
import type { AgStudioRef } from "ag-studio-react";
import { AgStudio } from "ag-studio-react";
import React, {
StrictMode,
useCallback,
useEffect,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const EMPTY_STATE: AgReportState = {
pages: [
{
id: "page-1",
},
],
selectedPageId: "page-1",
};
const HARDCODED_STATE: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
"2": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
"2": {
xTrack: 0,
yTrack: 16,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
const StudioExample = () => {
const studioRef = useRef<AgStudioRef>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
const [initialState, setInitialState] =
useState<AgReportState>(HARDCODED_STATE);
const [savedState, setSavedState] = useState<AgReportState>(EMPTY_STATE);
const [studioVisible, setStudioVisible] = useState(true);
useEffect(() => {
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) =>
setData({
sources: [{ id: "medals", data }],
}),
);
}, []);
const onStateUpdated = useCallback(
({ state }: AgStudioStateUpdatedEvent): void => {
console.log("State updated", state);
},
[],
);
const onStudioPreDestroyed = useCallback(
({ state }: AgStudioPreDestroyedEvent): void => {
console.log("Studio state on destroy", state);
setInitialState(state);
},
[],
);
const clearState = useCallback(() => {
studioRef.current!.api.setState(EMPTY_STATE);
}, []);
const saveState = useCallback(() => {
const state = studioRef.current!.api.getState();
console.log("Current state", state);
setSavedState(state);
}, []);
const restoreState = useCallback(() => {
studioRef.current!.api.setState(savedState);
}, [savedState]);
const hardcodedState = useCallback(() => {
studioRef.current!.api.setState(HARDCODED_STATE);
}, []);
const recreate = useCallback(() => {
setStudioVisible(false);
setTimeout(() => {
setStudioVisible(true);
});
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<div className="example-controls">
<div className="controls-row">
<button onClick={clearState}>Clear State</button>
<button onClick={saveState}>Save State</button>
<button onClick={restoreState}>Restore State</button>
<button onClick={hardcodedState}>Load Hardcoded State</button>
<button onClick={recreate}>
Recreate Studio with Current State
</button>
</div>
</div>
{studioVisible && (
<AgStudio
ref={studioRef}
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
mode={"edit"}
onStateUpdated={onStateUpdated}
onStudioPreDestroyed={onStudioPreDestroyed}
/>
)}
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);
const initialState = useMemo(() => {
return {
pages: [
{
id: 'page-1',
widgets: {
'1': {
type: 'grid',
dataMapping: {
cols: [
{ id: 'medals.country' },
],
},
},
},
widgetLayout: {
'1': {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: 'page-1',
};
}, []);
<AgStudio initialState={initialState} />State is provided to Studio on initialisation via the initialState property.
Changes to state can also be stepped back and forward - see Undo & Redo.
State can be saved and restored on demand via the API methods getState() and setState().
Any time state changes, a stateUpdated event is emitted with the latest state. When Studio is destroyed, the studioPreDestroyed event is fired, which contains the latest state at the time.
These are all demonstrated in the above example. See the State API below for more details.
State is immutable. Studio uses reference equality to detect which parts of the state have changed, and updates them accordingly. If updating state and providing it back to Studio, ensure that a shallow copy is made to the depth of the changes.
Modes and State Copy Link
Switching between edit and view mode changes only what is shown and what is editable. The active state carries across the switch unchanged; Studio neither saves nor restores state on a mode change.
State changes made in view mode are emitted through stateUpdated exactly as in edit mode.
Applications that don't want to persist any view mode changes can do so themselves (e.g. where any edits made in view mode are discarded on returning to edit mode). Call getState() immediately before setting mode to 'view', and setState() with the saved state when setting mode back to 'edit':
const savedState = api.getState();
api.setProperty('mode', 'view');
// later, when returning to edit mode
api.setProperty('mode', 'edit');
api.setState(savedState); Changing Pages Copy Link
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const StudioExample = () => {
const studioRef = useRef<AgStudioRef>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
const initialState = useMemo<AgReportState>(() => {
return {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
{
id: "page-2",
widgets: {
"1": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
}, []);
const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) =>
setData({
sources: [{ id: "medals", data }],
}),
);
}, []);
const updatePage = useCallback((pageId: string) => {
const state = studioRef.current!.api.getState();
studioRef.current!.api.setState({
...state,
selectedPageId: pageId,
});
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<div className="example-controls">
<div className="controls-row">
<button onClick={() => updatePage("page-1")}>Page 1</button>
<button onClick={() => updatePage("page-2")}>Page 2</button>
</div>
</div>
<AgStudio
ref={studioRef}
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
mode={"edit"}
onApiReady={onApiReady}
/>
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);
Reports support multiple pages. These are all defined in state, with the currently displayed page set via the top-level selectedPageId state property. The page can be changed by getting the latest state from Studio and setting back a copy with the selectedPageId updated.
const state = api.getState();
api.setState({
...state,
selectedPageId: 'page-2',
}); Invalid State Copy Link
When state is invalid, Studio will do a "best-effort" attempt to load the state. This generally means removing invalid properties, which can leave widgets incomplete.
In Edit Mode, the UI can be used to fix the properties that were invalid, however in View Mode the user cannot make updates.
Studio will emit an errorRaised event with errorType: 'state' when there is invalid state (see Studio Events for how to listen to events). When in View Mode, where the report cannot be loaded properly, the event will have fatal: true.
It is recommended that you handle fatal error events by preventing the user from interacting with Studio. E.g. hiding Studio with your own error component, prompting the user to load a different report, switching into Edit Mode if the user has permissions, etc.
To help avoid invalid state, we strongly recommend creating state in the UI and then retrieving it from Studio. You can then make minor tweaks if required, rather than hand-crafting the entire state object.
State Versioning Copy Link
If there are breaking changes to the shape of the state object, Studio will try to automatically upgrade any provided state based on the version property.
version is always set with the current version when retrieving state from Studio.
If version is not set, Studio will assume that the state is for the current version, and will not perform any migrations.
Ensure that any saved-down state is read from Studio or has the version set. Otherwise you will have to manually update it if there are breaking changes to the shape of the state object.
State API Copy Link
Properties Copy Link
Initial state for Studio. Only read once on initialization. Can be used in conjunction with api.getState() to save and restore Studio state. |
API Methods Copy Link
Get the current state of Studio.
Can be used in conjunction with the initialState Studio property
or api.setState() to save and restore Studio state. |
Set the current state of Studio.
Can be used in conjunction with api.getState() or onStateUpdated
to save and restore Studio state.
The state is expected to be a full state object, not a partial state object.
State must be updated immutably as Studio uses reference equality
to determine which parts of state have changed. |
Events Copy Link
State has been updated. |
Invoked immediately before Studio is destroyed. This is useful for cleanup logic that needs to run before Studio is torn down. |

Studio state allows reports to be saved and restored. Reports can be created in edit mode, saved down as state, and then reloaded in view mode.
Saving and Restoring State Copy Link
import type {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioPreDestroyedEvent,
AgStudioStateUpdatedEvent,
} from "ag-studio";
import { enableStudioDevValidations } from "ag-studio";
import { AgStudio } from "ag-studio-vue3";
import { createApp, defineComponent, ref, shallowRef } from "vue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const HARDCODED_STATE: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
"2": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
"2": {
xTrack: 0,
yTrack: 16,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
const EMPTY_STATE: AgReportState = {
pages: [
{
id: "page-1",
},
],
selectedPageId: "page-1",
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button v-on:click="clearState()">Clear State</button>
<button v-on:click="saveState()">Save State</button>
<button v-on:click="restoreState()">Restore State</button>
<button v-on:click="hardcodedState()">Load Hardcoded State</button>
<button v-on:click="recreate()">Recreate Studio with Current State</button>
</div>
</div>
<ag-studio
v-if="studioVisible"
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:mode="mode"
:data="data"
@state-updated="onStateUpdated"
@studio-pre-destroyed="onStudioPreDestroyed"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi | null>(null);
const initialState = ref<AgReportState>(HARDCODED_STATE);
const mode = ref<AgStudioMode>("edit");
const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);
const savedState = ref<AgReportState>(EMPTY_STATE);
const studioVisible = ref(true);
const onStateUpdated: (event: AgStudioStateUpdatedEvent) => void = (
event: AgStudioStateUpdatedEvent,
) => {
console.log("State updated", event.state);
};
const onStudioPreDestroyed: (event: AgStudioPreDestroyedEvent) => void = (
event: AgStudioPreDestroyedEvent,
) => {
console.log("Studio state on destroy", event.state);
};
const clearState = () => {
studioApi.value.setState(EMPTY_STATE);
};
const saveState = () => {
const state = studioApi.value.getState();
console.log("Current state", state);
savedState.value = state;
};
const restoreState = () => {
studioApi.value.setState(savedState.value);
};
const hardcodedState = () => {
studioApi.value.setState(HARDCODED_STATE);
};
const recreate = () => {
const state = studioApi.value.getState();
studioVisible.value = false;
setTimeout(() => {
initialState.value = state;
data.value = undefined;
studioVisible.value = true;
});
};
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
const getData = (data: any[]) => ({
sources: [{ id: "medals", data }],
});
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((respData) => (data.value = getData(respData)));
};
return {
studioApi,
initialState,
mode,
data,
studioVisible,
onApiReady,
onStateUpdated,
onStudioPreDestroyed,
clearState,
saveState,
restoreState,
hardcodedState,
recreate,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
<ag-studio
:initialState="initialState"
/* other studio properties ... */>
</ag-studio>
this.initialState = {
pages: [
{
id: 'page-1',
widgets: {
'1': {
type: 'grid',
dataMapping: {
cols: [
{ id: 'medals.country' },
],
},
},
},
widgetLayout: {
'1': {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: 'page-1',
};State is provided to Studio on initialisation via the initialState property.
Changes to state can also be stepped back and forward - see Undo & Redo.
State can be saved and restored on demand via the API methods getState() and setState().
Any time state changes, a stateUpdated event is emitted with the latest state. When Studio is destroyed, the studioPreDestroyed event is fired, which contains the latest state at the time.
These are all demonstrated in the above example. See the State API below for more details.
State is immutable. Studio uses reference equality to detect which parts of the state have changed, and updates them accordingly. If updating state and providing it back to Studio, ensure that a shallow copy is made to the depth of the changes.
Modes and State Copy Link
Switching between edit and view mode changes only what is shown and what is editable. The active state carries across the switch unchanged; Studio neither saves nor restores state on a mode change.
State changes made in view mode are emitted through stateUpdated exactly as in edit mode.
Applications that don't want to persist any view mode changes can do so themselves (e.g. where any edits made in view mode are discarded on returning to edit mode). Call getState() immediately before setting mode to 'view', and setState() with the saved state when setting mode back to 'edit':
const savedState = api.getState();
api.setProperty('mode', 'view');
// later, when returning to edit mode
api.setProperty('mode', 'edit');
api.setState(savedState); Changing Pages Copy Link
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button v-on:click="updatePage('page-1')">Page 1</button>
<button v-on:click="updatePage('page-2')">Page 2</button>
</div>
</div>
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:mode="mode"
:data="data"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi | null>(null);
const initialState = ref<AgReportState>({
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
{
id: "page-2",
widgets: {
"1": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
});
const mode = ref<AgStudioMode>("edit");
const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);
function updatePage(pageId: string) {
const state = studioApi.value.getState();
studioApi.value.setState({
...state,
selectedPageId: pageId,
});
}
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
const toStudioData = (data) => ({
sources: [{ id: "medals", data }],
});
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((respData) => (data.value = toStudioData(respData)));
};
return {
studioApi,
initialState,
mode,
data,
onApiReady,
updatePage,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Reports support multiple pages. These are all defined in state, with the currently displayed page set via the top-level selectedPageId state property. The page can be changed by getting the latest state from Studio and setting back a copy with the selectedPageId updated.
const state = api.getState();
api.setState({
...state,
selectedPageId: 'page-2',
}); Invalid State Copy Link
When state is invalid, Studio will do a "best-effort" attempt to load the state. This generally means removing invalid properties, which can leave widgets incomplete.
In Edit Mode, the UI can be used to fix the properties that were invalid, however in View Mode the user cannot make updates.
Studio will emit an errorRaised event with errorType: 'state' when there is invalid state (see Studio Events for how to listen to events). When in View Mode, where the report cannot be loaded properly, the event will have fatal: true.
It is recommended that you handle fatal error events by preventing the user from interacting with Studio. E.g. hiding Studio with your own error component, prompting the user to load a different report, switching into Edit Mode if the user has permissions, etc.
To help avoid invalid state, we strongly recommend creating state in the UI and then retrieving it from Studio. You can then make minor tweaks if required, rather than hand-crafting the entire state object.
State Versioning Copy Link
If there are breaking changes to the shape of the state object, Studio will try to automatically upgrade any provided state based on the version property.
version is always set with the current version when retrieving state from Studio.
If version is not set, Studio will assume that the state is for the current version, and will not perform any migrations.
Ensure that any saved-down state is read from Studio or has the version set. Otherwise you will have to manually update it if there are breaking changes to the shape of the state object.
State API Copy Link
Properties Copy Link
Initial state for Studio. Only read once on initialization. Can be used in conjunction with api.getState() to save and restore Studio state. |
API Methods Copy Link
Get the current state of Studio.
Can be used in conjunction with the initialState Studio property
or api.setState() to save and restore Studio state. |
Set the current state of Studio.
Can be used in conjunction with api.getState() or onStateUpdated
to save and restore Studio state.
The state is expected to be a full state object, not a partial state object.
State must be updated immutably as Studio uses reference equality
to determine which parts of state have changed. |
Events Copy Link
State has been updated. |
Invoked immediately before Studio is destroyed. This is useful for cleanup logic that needs to run before Studio is torn down. |

Studio state allows reports to be saved and restored. Reports can be created in edit mode, saved down as state, and then reloaded in view mode.
Saving and Restoring State Copy Link
import { HttpClient } from "@angular/common/http";
import { Component, signal } from "@angular/core";
import type {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioPreDestroyedEvent,
AgStudioStateUpdatedEvent,
} from "ag-studio";
import { enableStudioDevValidations } from "ag-studio";
import { AgStudio } from "ag-studio-angular";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const HARDCODED_STATE: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
"2": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
"2": {
xTrack: 0,
yTrack: 16,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
const EMPTY_STATE: AgReportState = {
pages: [
{
id: "page-1",
},
],
selectedPageId: "page-1",
};
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button (click)="clearState()">Clear State</button>
<button (click)="saveState()">Save State</button>
<button (click)="restoreState()">Restore State</button>
<button (click)="hardcodedState()">Load Hardcoded State</button>
<button (click)="recreate()">Recreate Studio with Current State</button>
</div>
</div>
@if (studioVisible()) {
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[mode]="mode"
[data]="data"
(stateUpdated)="onStateUpdated($event)"
(studioPreDestroyed)="onStudioPreDestroyed($event)"
(apiReady)="onApiReady($event)"
/>
}
</div> `,
})
export class AppComponent {
private studioApi!: AgStudioApi;
initialState: AgReportState = HARDCODED_STATE;
mode: AgStudioMode = "edit";
data?: AgDataSourcesDefinition | AgDataEngine;
studioVisible = signal(true);
private savedState: AgReportState = EMPTY_STATE;
constructor(private http: HttpClient) {}
onStateUpdated(event: AgStudioStateUpdatedEvent): void {
console.log("State updated", event.state);
}
onStudioPreDestroyed(event: AgStudioPreDestroyedEvent): void {
console.log("Studio state on destroy", event.state);
}
clearState() {
this.studioApi.setState(EMPTY_STATE);
}
saveState() {
const state = this.studioApi.getState();
console.log("Current state", state);
this.savedState = state;
}
restoreState() {
this.studioApi.setState(this.savedState);
}
hardcodedState() {
this.studioApi.setState(HARDCODED_STATE);
}
recreate() {
const state = this.studioApi.getState();
this.studioVisible.set(false);
this.initialState = state;
this.data = undefined;
setTimeout(() => {
this.studioVisible.set(true);
});
}
onApiReady(params: AgStudioApiReadyEvent) {
this.studioApi = params.api;
this.http
.get<any[]>("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.subscribe(
(data) =>
(this.data = {
sources: [{ id: "medals", data }],
}),
);
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component.ts';
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
<ag-studio
[initialState]="initialState"
/* other studio properties ... */ />
this.initialState = {
pages: [
{
id: 'page-1',
widgets: {
'1': {
type: 'grid',
dataMapping: {
cols: [
{ id: 'medals.country' },
],
},
},
},
widgetLayout: {
'1': {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 16,
},
},
},
],
selectedPageId: 'page-1',
};State is provided to Studio on initialisation via the initialState property.
Changes to state can also be stepped back and forward - see Undo & Redo.
State can be saved and restored on demand via the API methods getState() and setState().
Any time state changes, a stateUpdated event is emitted with the latest state. When Studio is destroyed, the studioPreDestroyed event is fired, which contains the latest state at the time.
These are all demonstrated in the above example. See the State API below for more details.
State is immutable. Studio uses reference equality to detect which parts of the state have changed, and updates them accordingly. If updating state and providing it back to Studio, ensure that a shallow copy is made to the depth of the changes.
Modes and State Copy Link
Switching between edit and view mode changes only what is shown and what is editable. The active state carries across the switch unchanged; Studio neither saves nor restores state on a mode change.
State changes made in view mode are emitted through stateUpdated exactly as in edit mode.
Applications that don't want to persist any view mode changes can do so themselves (e.g. where any edits made in view mode are discarded on returning to edit mode). Call getState() immediately before setting mode to 'view', and setState() with the saved state when setting mode back to 'edit':
const savedState = api.getState();
api.setProperty('mode', 'view');
// later, when returning to edit mode
api.setProperty('mode', 'edit');
api.setState(savedState); Changing Pages Copy Link
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgStudio } from "ag-studio-angular";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<div class="example-controls">
<div class="controls-row">
<button (click)="updatePage('page-1')">Page 1</button>
<button (click)="updatePage('page-2')">Page 2</button>
</div>
</div>
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[mode]="mode"
[data]="data"
(apiReady)="onApiReady($event)"
/>
</div> `,
})
export class AppComponent {
private studioApi!: AgStudioApi;
initialState: AgReportState = {
pages: [
{
id: "page-1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "medals.country" },
{ id: "medals.sport" },
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
{ id: "medals.total", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
{
id: "page-2",
widgets: {
"1": {
type: "column-chart-grouped",
dataMapping: {
categoryKey: [{ id: "medals.country" }],
valueKey: [
{ id: "medals.gold", aggregation: "sum" },
{ id: "medals.silver", aggregation: "sum" },
{ id: "medals.bronze", aggregation: "sum" },
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 24,
},
},
},
],
selectedPageId: "page-1",
panels: {
filters: {
collapsed: true,
},
},
};
mode: AgStudioMode = "edit";
data!: AgDataSourcesDefinition | AgDataEngine;
constructor(private http: HttpClient) {}
updatePage(pageId: string) {
const state = this.studioApi.getState();
this.studioApi.setState({
...state,
selectedPageId: pageId,
});
}
onApiReady(params: AgStudioApiReadyEvent) {
this.studioApi = params.api;
this.http
.get("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.subscribe(
(data) =>
(this.data = {
sources: [{ id: "medals", data }],
}),
);
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component.ts';
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Reports support multiple pages. These are all defined in state, with the currently displayed page set via the top-level selectedPageId state property. The page can be changed by getting the latest state from Studio and setting back a copy with the selectedPageId updated.
const state = api.getState();
api.setState({
...state,
selectedPageId: 'page-2',
}); Invalid State Copy Link
When state is invalid, Studio will do a "best-effort" attempt to load the state. This generally means removing invalid properties, which can leave widgets incomplete.
In Edit Mode, the UI can be used to fix the properties that were invalid, however in View Mode the user cannot make updates.
Studio will emit an errorRaised event with errorType: 'state' when there is invalid state (see Studio Events for how to listen to events). When in View Mode, where the report cannot be loaded properly, the event will have fatal: true.
It is recommended that you handle fatal error events by preventing the user from interacting with Studio. E.g. hiding Studio with your own error component, prompting the user to load a different report, switching into Edit Mode if the user has permissions, etc.
To help avoid invalid state, we strongly recommend creating state in the UI and then retrieving it from Studio. You can then make minor tweaks if required, rather than hand-crafting the entire state object.
State Versioning Copy Link
If there are breaking changes to the shape of the state object, Studio will try to automatically upgrade any provided state based on the version property.
version is always set with the current version when retrieving state from Studio.
If version is not set, Studio will assume that the state is for the current version, and will not perform any migrations.
Ensure that any saved-down state is read from Studio or has the version set. Otherwise you will have to manually update it if there are breaking changes to the shape of the state object.
State API Copy Link
Properties Copy Link
Initial state for Studio. Only read once on initialization. Can be used in conjunction with api.getState() to save and restore Studio state. |
API Methods Copy Link
Get the current state of Studio.
Can be used in conjunction with the initialState Studio property
or api.setState() to save and restore Studio state. |
Set the current state of Studio.
Can be used in conjunction with api.getState() or onStateUpdated
to save and restore Studio state.
The state is expected to be a full state object, not a partial state object.
State must be updated immutably as Studio uses reference equality
to determine which parts of state have changed. |
Events Copy Link
State has been updated. |
Invoked immediately before Studio is destroyed. This is useful for cleanup logic that needs to run before Studio is torn down. |